#
# spec file for package ghc-stm-containers
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name stm-containers
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.2.16
Release:        3.10
Summary:        Containers for STM
License:        MIT
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-base-prelude-devel
BuildRequires:  ghc-focus-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-list-t-devel
BuildRequires:  ghc-primitive-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-transformers-devel
%if %{with tests}
BuildRequires:  ghc-HTF-devel
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-free-devel
BuildRequires:  ghc-loch-th-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-mtl-prelude-devel
BuildRequires:  ghc-placeholders-devel
BuildRequires:  ghc-unordered-containers-devel
%endif

%description
This library is based on an STM-specialized implementation of Hash Array Mapped
Trie. It provides efficient implementations of 'Map', 'Set' and other data
structures, which are marginally slower than their counterparts from
"unordered-containers", but scale well on concurrent access patterns.

For details on performance of the library see
<http://nikita-volkov.github.io/stm-containers/ this blog post>.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files

%changelog
* Tue Jul 10 2018 psimons@suse.com
- Add stm-containers at version 0.2.16.
